OGRE: Ogre::v1::Skeleton Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
Ogre::v1::Skeleton Class Reference
Core » Animation

A collection of OldBone objects used to animate a skinned mesh. More...

`#include <OgreSkeleton.h>`

Inheritance diagram for Ogre::v1::Skeleton:
[legend]

## Public Types
typedef vector< ushort >::type | BoneHandleMap
| Map to translate bone handle from one skeleton to another skeleton. More...
typedef VectorIterator< BoneList > | BoneIterator
typedef vector< OldBone * >::type | BoneList
typedef ConstVectorIterator< BoneList > | ConstBoneIterator
typedef ConstVectorIterator< LinkedSkeletonAnimSourceList > | LinkedSkeletonAnimSourceIterator
typedef vector< LinkedSkeletonAnimationSource >::type | LinkedSkeletonAnimSourceList
enum | LoadingFlags { LF_DEFAULT = 0, LF_INCLUDE_NON_RELOADABLE = 1, LF_ONLY_UNREFERENCED = 2, LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3, LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...

## Public Member Functions
| Skeleton (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, don't call directly, use SkeletonManager. More...
virtual | ~Skeleton ()
virtual void | _buildMapBoneByHandle (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations. More...
virtual void | _buildMapBoneByName (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations. More...
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed. More...
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event. More...
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event. More...
virtual void | _fireUnloadingComplete (void)
| Firing of unloading complete event. More...
virtual Animation * | _getAnimationImpl (const String &name, const LinkedSkeletonAnimationSource **linker=0) const
| Internal accessor for animations (returns null if animation does not exist) More...
virtual void | _getBoneMatrices (Matrix4 *pMatrices)
| Populates the passed in array with the bone matrices based on the current position. More...
virtual void | _initAnimationState (AnimationStateSet *animSet)
| Initialise an animation set suitable for use with this skeleton. More...
virtual void | _mergeSkeletonAnimations (const Skeleton *source, const BoneHandleMap &boneHandleMap, const StringVector &animations=StringVector())
| Merge animations from another Skeleton object into this skeleton. More...
virtual void | _notifyManualBonesDirty (void)
| Internal method for marking the manual bones as dirty. More...
virtual void | _notifyManualBoneStateChange (OldBone *bone)
| Internal method for notifying that a bone is manual. More...
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin. More...
virtual void | _refreshAnimationState (AnimationStateSet *animSet)
| Refresh an animation set suitable for use with this skeleton. More...
virtual void | _updateTransforms (void)
| Updates all the derived transforms in the skeleton. More...
virtual void | addLinkedSkeletonAnimationSource (const String &skelName, Real scale=1.0f)
| Allows you to use the animations from another Skeleton object to animate this skeleton. More...
virtual void | addListener (Listener *lis)
| Register a listener on this resource. More...
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource. More...
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
virtual Animation * | createAnimation (const String &name, Real length)
| Creates a new Animation object for animating this skeleton. More...
virtual OldBone * | createBone (const String &name)
| Creates a brand new OldBone owned by this Skeleton. More...
virtual OldBone * | createBone (const String &name, unsigned short handle)
| Creates a brand new OldBone owned by this Skeleton. More...
virtual OldBone * | createBone (unsigned short handle)
| Creates a brand new OldBone owned by this Skeleton. More...
virtual OldBone * | createBone (void)
| Creates a brand new OldBone owned by this Skeleton. More...
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource. More...
virtual Animation * | getAnimation (const String &name) const
| Returns the named Animation object. More...
virtual Animation * | getAnimation (const String &name, const LinkedSkeletonAnimationSource **linker) const
| Returns the named Animation object. More...
virtual Animation * | getAnimation (unsigned short index) const
| Gets a single animation by index. More...
virtual SkeletonAnimationBlendMode | getBlendMode () const
| Gets the animation blending mode which this skeleton will use. More...
virtual OldBone * | getBone (const String &name) const
| Gets a bone by it's name. More...
virtual OldBone * | getBone (unsigned short handle) const
| Gets a bone by it's handle. More...
virtual BoneIterator | getBoneIterator (void)
| Get an iterator over all the bones in the skeleton. More...
ConstBoneIterator | getBoneIteratorConst (void) const
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource. More...
virtual const String & | getGroup (void) const
| Gets the group which this resource is a member of. More...
virtual ResourceHandle | getHandle (void) const
virtual LinkedSkeletonAnimSourceIterator | getLinkedSkeletonAnimationSourceIterator (void) const
| Get an iterator over the linked skeletons used as animation sources. More...
virtual LoadingState | getLoadingState () const
| Returns the current loading state. More...
virtual bool | getManualBonesDirty (void) const
| Have manual bones been modified since the skeleton was last updated? More...
virtual const String & | getName (void) const
| Gets resource name. More...
virtual unsigned short | getNumAnimations (void) const
| Gets the number of animations on this skeleton. More...
virtual unsigned short | getNumBones (void) const
| Returns the number of bones in this skeleton. More...
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
virtual OldBone * | getRootBone (void) const
| Gets the root bone of the skeleton: deprecated in favour of getRootBoneIterator. More...
virtual BoneIterator | getRootBoneIterator (void)
| Get an iterator over the root bones in the skeleton, ie those with no parents. More...
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource. More...
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded. More...
virtual bool | hasAnimation (const String &name) const
| Returns whether this skeleton contains the named animation. More...
virtual bool | hasBone (const String &name) const
| Returns whether this skeleton contains the named bone. More...
virtual bool | hasManualBones (void) const
| Are there any manually controlled bones? More...
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading. More...
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise. More...
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading. More...
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded? More...
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise. More...
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise. More...
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | optimiseAllAnimations (bool preservingIdentityNodeTracks=false)
| Optimise all of this skeleton's animations. More...
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already. More...
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded. More...
virtual void | removeAllLinkedSkeletonAnimationSources (void)
| Remove all links to other skeletons for the purposes of sharing animation. More...
virtual void | removeAnimation (const String &name)
| Removes an Animation from this skeleton. More...
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource. More...
virtual void | reset (bool resetManualBones=false)
| Resets the position and orientation of all bones in this skeleton to their original binding position. More...
virtual void | setAnimationState (const AnimationStateSet &animSet)
| Changes the state of the skeleton to reflect the application of the passed in collection of animations. More...
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not. More...
virtual void | setBindingPose (void)
| Sets the current position / orientation to be the 'binding pose' i.e. More...
virtual void | setBlendMode (SkeletonAnimationBlendMode state)
| Sets the animation blending mode this skeleton will use. More...
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?". More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
virtual void | setToLoaded (void)
| Change the Resource loading state to loaded. More...
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used. More...
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Public Attributes
| OGRE_AUTO_MUTEX

## Friends
class | OldSkeletonInstance

## Detailed Description

A collection of OldBone objects used to animate a skinned mesh.

Remarks
  Skeletal animation works by having a collection of 'bones' which are actually just joints with a position and orientation, arranged in a tree structure. For example, the wrist joint is a child of the elbow joint, which in turn is a child of the shoulder joint. Rotating the shoulder automatically moves the elbow and wrist as well due to this hierarchy.

  So how does this animate a mesh? Well every vertex in a mesh is assigned to one or more bones which affects it's position when the bone is moved. If a vertex is assigned to more than one bone, then weights must be assigned to determine how much each bone affects the vertex (actually a weight of 1.0 is used for single bone assignments). Weighted vertex assignments are especially useful around the joints themselves to avoid 'pinching' of the mesh in this region.

  Therefore by moving the skeleton using preset animations, we can animate the mesh. The advantage of using skeletal animation is that you store less animation data, especially as vertex counts increase. In addition, you are able to blend multiple animations together (e.g. walking and looking around, running and shooting) and provide smooth transitions between animations without incurring as much of an overhead as would be involved if you did this on the core vertex data.

  Skeleton definitions are loaded from datafiles, namely the .skeleton file format. They are loaded on demand, especially when referenced by a Mesh.

## Member Typedef Documentation

## ◆ BoneHandleMap

typedef vector<ushort>::type Ogre::v1::Skeleton::BoneHandleMap

Map to translate bone handle from one skeleton to another skeleton.

## ◆ BoneIterator

typedef VectorIterator<BoneList> Ogre::v1::Skeleton::BoneIterator

## ◆ BoneList

typedef vector<OldBone*>::type Ogre::v1::Skeleton::BoneList

## ◆ ConstBoneIterator

typedef ConstVectorIterator<BoneList> Ogre::v1::Skeleton::ConstBoneIterator

## ◆ LinkedSkeletonAnimSourceIterator

typedef ConstVectorIterator<LinkedSkeletonAnimSourceList> Ogre::v1::Skeleton::LinkedSkeletonAnimSourceIterator

## ◆ LinkedSkeletonAnimSourceList

typedef vector<LinkedSkeletonAnimationSource>::type Ogre::v1::Skeleton::LinkedSkeletonAnimSourceList

## Member Enumeration Documentation

## ◆ LoadingFlags

enum Ogre::Resource::LoadingFlags
| inherited

Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior.

Enumerator
LF_DEFAULT | Only reloadable resources are processed, reload restores initial state.
LF_INCLUDE_NON_RELOADABLE | Process non-reloadable resources too.
LF_ONLY_UNREFERENCED | Process only resources which are not referenced by any other object. Usefull to reduce resource consumption.
LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE | Combination of LF_ONLY_UNREFERENCED and LF_INCLUDE_NON_RELOADABLE.
LF_PRESERVE_STATE | Preserve some states during reloading, for example stencil shadows prepareness for Meshes.

## ◆ LoadingState

enum Ogre::Resource::LoadingState
| inherited

Enum identifying the loading state of the resource.

Enumerator
LOADSTATE_UNLOADED | Not loaded.
LOADSTATE_LOADING | Loading is in progress.
LOADSTATE_LOADED | Fully loaded.
LOADSTATE_UNLOADING | Currently unloading.
LOADSTATE_PREPARED | Fully prepared.
LOADSTATE_PREPARING | Preparing is in progress.

## Constructor & Destructor Documentation

## ◆ Skeleton()

Ogre::v1::Skeleton::Skeleton | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`
| ) |  |

Constructor, don't call directly, use SkeletonManager.

Remarks
  On creation, a Skeleton has a no bones, you should create them and link them together appropriately.

## ◆ ~Skeleton()

virtual Ogre::v1::Skeleton::~Skeleton | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _buildMapBoneByHandle()

virtual void Ogre::v1::Skeleton::_buildMapBoneByHandle | ( | const Skeleton * | source,
|  | BoneHandleMap & | boneHandleMap
| ) |  | const
| virtual

Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.

Remarks
  Identically bones are determine by handle.

## ◆ _buildMapBoneByName()

virtual void Ogre::v1::Skeleton::_buildMapBoneByName | ( | const Skeleton * | source,
|  | BoneHandleMap & | boneHandleMap
| ) |  | const
| virtual

Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.

Remarks
  Identically bones are determine by name.

## ◆ _dirtyState()

virtual void Ogre::Resource::_dirtyState | ( |  | ) |
| virtualinherited

Manually mark the state of this resource as having been changed.

Remarks
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also
  getStateCount.

## ◆ _fireLoadingComplete()

virtual void Ogre::Resource::_fireLoadingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of loading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _firePreparingComplete()

virtual void Ogre::Resource::_firePreparingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of preparing complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _fireUnloadingComplete()

virtual void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) |
| virtualinherited

Firing of unloading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

## ◆ _getAnimationImpl()

virtual Animation* Ogre::v1::Skeleton::_getAnimationImpl | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker = `0`
| ) |  | const
| virtual

Internal accessor for animations (returns null if animation does not exist)

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ _getBoneMatrices()

virtual void Ogre::v1::Skeleton::_getBoneMatrices | ( | Matrix4 * | pMatrices | ) |
| virtual

Populates the passed in array with the bone matrices based on the current position.

Remarks
  Internal use only. The array pointed to by the passed in pointer must be at least as large as the number of bones. Assumes animation has already been updated.

## ◆ _initAnimationState()

virtual void Ogre::v1::Skeleton::_initAnimationState | ( | AnimationStateSet * | animSet | ) |
| virtual

Initialise an animation set suitable for use with this skeleton.

Remarks
  Only recommended for use inside the engine, not by applications.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ _mergeSkeletonAnimations()

virtual void Ogre::v1::Skeleton::_mergeSkeletonAnimations | ( | const Skeleton * | source,
|  | const BoneHandleMap & | boneHandleMap,
|  | const StringVector & | animations = `StringVector()`
| ) |  |
| virtual

Merge animations from another Skeleton object into this skeleton.

Remarks
  This function allow merge two structures compatible skeletons. The 'compatible' here means identically bones will have same hierarchy, but skeletons are not necessary to have same number of bones (if number bones of source skeleton's more than this skeleton, they will copied as is, except that duplicate names are disallowed; and in the case of bones missing in source skeleton, nothing happen for those bones).

  There are also unnecessary to have same binding poses, this function will adjust keyframes of the source skeleton to match this skeleton automatically.

  It's useful for exporting skeleton animations separately. i.e. export mesh and 'master' skeleton at the same time, and then other animations will export separately (even if used completely difference binding pose), finally, merge separately exported animations into 'master' skeleton.

Parameters

  source | Pointer to source skeleton. It'll keep unmodified.
  boneHandleMap | A map to translate identically bone's handle from source skeleton to this skeleton. If mapped bone handle doesn't exists in this skeleton, it'll created. You can populate bone handle map manually, or use predefined functions build bone handle map for you. (

See also
  _buildMapBoneByHandle, _buildMapBoneByName)

Parameters

  animations | A list name of animations to merge, if empty, all animations of source skeleton are used to merge. Note that the animation names must not presented in this skeleton, and will NOT pick up animations in linked skeletons (

See also
  addLinkedSkeletonAnimationSource).

## ◆ _notifyManualBonesDirty()

virtual void Ogre::v1::Skeleton::_notifyManualBonesDirty | ( | void |  | ) |
| virtual

Internal method for marking the manual bones as dirty.

## ◆ _notifyManualBoneStateChange()

virtual void Ogre::v1::Skeleton::_notifyManualBoneStateChange | ( | OldBone * | bone | ) |
| virtual

Internal method for notifying that a bone is manual.

## ◆ _notifyOrigin()

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) |
| inlinevirtualinherited

Notify this resource of it's origin.

## ◆ _refreshAnimationState()

virtual void Ogre::v1::Skeleton::_refreshAnimationState | ( | AnimationStateSet * | animSet | ) |
| virtual

Refresh an animation set suitable for use with this skeleton.

Remarks
  Only recommended for use inside the engine, not by applications.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ _updateTransforms()

virtual void Ogre::v1::Skeleton::_updateTransforms | ( | void |  | ) |
| virtual

Updates all the derived transforms in the skeleton.

## ◆ addLinkedSkeletonAnimationSource()

virtual void Ogre::v1::Skeleton::addLinkedSkeletonAnimationSource | ( | const String & | skelName,
|  | Real | scale = `1.0f`
| ) |  |
| virtual

Allows you to use the animations from another Skeleton object to animate this skeleton.

Remarks
  If you have skeletons of identical structure (that means identically named bones with identical handles, and with the same hierarchy), but slightly different proportions or binding poses, you can re-use animations from one in the other. Because animations are actually stored as changes to bones from their bind positions, it's possible to use the same animation data for different skeletons, provided the skeletal structure matches and the 'deltas' stored in the keyframes apply equally well to the other skeletons bind position (so they must be roughly similar, but don't have to be identical). You can use the 'scale' option to adjust the translation and scale keyframes where there are large differences in size between the skeletons.

Note
  This method takes a skeleton name, rather than a more specific animation name, for two reasons; firstly it allows some validation of compatibility of skeletal structure, and secondly skeletons are the unit of loading. Linking a skeleton to another in this way means that the linkee will be prevented from being destroyed until the linker is destroyed.

You cannot set up cyclic relationships, e.g. SkeletonA uses SkeletonB's animations, and SkeletonB uses SkeletonA's animations. This is because it would set up a circular dependency which would prevent proper unloading - make one of the skeletons the 'master' in this case.

Parameters

  skelName | Name of the skeleton to link animations from. This skeleton will be loaded immediately if this skeleton is already loaded, otherwise it will be loaded when this skeleton is.
  scale | A scale factor to apply to translation and scaling elements of the keyframes in the other skeleton when applying the animations to this one. Compensates for skeleton size differences.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ addListener()

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) |
| virtualinherited

Register a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ changeGroupOwnership()

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) |
| virtualinherited

Change the resource group ownership of a Resource.

Remarks
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters

  newGroup | Name of the new group

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ createAnimation()

virtual Animation* Ogre::v1::Skeleton::createAnimation | ( | const String & | name,
|  | Real | length
| ) |  |
| virtual

Creates a new Animation object for animating this skeleton.

Parameters

  name | The name of this animation
  length | The length of the animation in seconds

Implements Ogre::v1::AnimationContainer.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ createBone() [1/4]

virtual OldBone* Ogre::v1::Skeleton::createBone | ( | const String & | name | ) |
| virtual

Creates a brand new OldBone owned by this Skeleton.

Remarks
  This method creates an unattached new OldBone for this skeleton and assigns it a specific name.Unless this is to be a root bone (there may be more than one of these), you must attach it to another OldBone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the OldBone::createChild method instead, once you have created the root bone.

Parameters

  name | The name to give to this new bone - must be unique within this skeleton. Note that the way OGRE looks up bones is via a numeric handle, so if you name a OldBone this way it will be given an automatic sequential handle. The name is just for your convenience, although it is recommended that you only use the handle to retrieve the bone in performance-critical code.

## ◆ createBone() [2/4]

virtual OldBone* Ogre::v1::Skeleton::createBone | ( | const String & | name,
|  | unsigned short | handle
| ) |  |
| virtual

Creates a brand new OldBone owned by this Skeleton.

Remarks
  This method creates an unattached new OldBone for this skeleton and assigns it a specific name and handle. Unless this is to be a root bone (there may be more than one of these), you must attach it to another OldBone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the OldBone::createChild method instead, once you have created the root bone.

Parameters

  name | The name to give to this new bone - must be unique within this skeleton.
  handle | The handle to give to this new bone - must be unique within this skeleton.

## ◆ createBone() [3/4]

virtual OldBone* Ogre::v1::Skeleton::createBone | ( | unsigned short | handle | ) |
| virtual

Creates a brand new OldBone owned by this Skeleton.

Remarks
  This method creates an unattached new OldBone for this skeleton and assigns it a specific handle. Unless this is to be a root bone (there may be more than one of these), you must attach it to another OldBone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the OldBone::createChild method instead, once you have created a root bone.

Parameters

  handle | The handle to give to this new bone - must be unique within this skeleton. You should also ensure that all bone handles are eventually contiguous (this is to simplify their compilation into an indexed array of transformation matrices). For this reason it is advised that you use the simpler createBone method which automatically assigns a sequential handle starting from 0.

## ◆ createBone() [4/4]

virtual OldBone* Ogre::v1::Skeleton::createBone | ( | void |  | ) |
| virtual

Creates a brand new OldBone owned by this Skeleton.

Remarks
  This method creates an unattached new OldBone for this skeleton. Unless this is to be a root bone (there may be more than one of these), you must attach it to another OldBone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the OldBone::createChild method instead, once you have created the root bone.

  Note that this method automatically generates a handle for the bone, which you can retrieve using OldBone::getHandle. If you wish the new OldBone to have a specific handle, use the alternate form of this method which takes a handle as a parameter, although you should note the restrictions.

## ◆ escalateLoading()

virtual void Ogre::Resource::escalateLoading | ( |  | ) |
| virtualinherited

Escalates the loading of a background loaded resource.

Remarks
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getAnimation() [1/3]

virtual Animation* Ogre::v1::Skeleton::getAnimation | ( | const String & | name | ) | const
| virtual

Returns the named Animation object.

Remarks
  Will pick up animations in linked skeletons (

See also
  addLinkedSkeletonAnimationSource).

Parameters

  name | The name of the animation

Implements Ogre::v1::AnimationContainer.

## ◆ getAnimation() [2/3]

virtual Animation* Ogre::v1::Skeleton::getAnimation | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker
| ) |  | const
| virtual

Returns the named Animation object.

Remarks
  Will pick up animations in linked skeletons (

See also
  addLinkedSkeletonAnimationSource).

Parameters

  name | The name of the animation
  linker | Optional pointer to a pointer to the linked skeleton animation where this is coming from.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getAnimation() [3/3]

virtual Animation* Ogre::v1::Skeleton::getAnimation | ( | unsigned short | index | ) | const
| virtual

Gets a single animation by index.

Remarks
  Will NOT pick up animations in linked skeletons (

See also
  addLinkedSkeletonAnimationSource).

Implements Ogre::v1::AnimationContainer.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getBlendMode()

virtual SkeletonAnimationBlendMode Ogre::v1::Skeleton::getBlendMode | ( |  | ) | const
| virtual

Gets the animation blending mode which this skeleton will use.

## ◆ getBone() [1/2]

virtual OldBone* Ogre::v1::Skeleton::getBone | ( | const String & | name | ) | const
| virtual

Gets a bone by it's name.

## ◆ getBone() [2/2]

virtual OldBone* Ogre::v1::Skeleton::getBone | ( | unsigned short | handle | ) | const
| virtual

Gets a bone by it's handle.

## ◆ getBoneIterator()

virtual BoneIterator Ogre::v1::Skeleton::getBoneIterator | ( | void |  | ) |
| virtual

Get an iterator over all the bones in the skeleton.

## ◆ getBoneIteratorConst()

ConstBoneIterator Ogre::v1::Skeleton::getBoneIteratorConst | ( | void |  | ) | const

## ◆ getCreator()

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) |
| inlinevirtualinherited

Gets the manager which created this resource.

## ◆ getGroup()

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | const
| inlinevirtualinherited

Gets the group which this resource is a member of.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getHandle()

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const
| inlinevirtualinherited

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getLinkedSkeletonAnimationSourceIterator()

virtual LinkedSkeletonAnimSourceIterator Ogre::v1::Skeleton::getLinkedSkeletonAnimationSourceIterator | ( | void |  | ) | const
| virtual

Get an iterator over the linked skeletons used as animation sources.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getLoadingState()

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const
| inlinevirtualinherited

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ getManualBonesDirty()

virtual bool Ogre::v1::Skeleton::getManualBonesDirty | ( | void |  | ) | const
| inlinevirtual

Have manual bones been modified since the skeleton was last updated?

## ◆ getName()

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const
| inlinevirtualinherited

Gets resource name.

Reimplemented in Ogre::v1::OldSkeletonInstance.

Referenced by Ogre::GpuProgramUsage::getProgramName().

## ◆ getNumAnimations()

virtual unsigned short Ogre::v1::Skeleton::getNumAnimations | ( | void |  | ) | const
| virtual

Gets the number of animations on this skeleton.

Implements Ogre::v1::AnimationContainer.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getNumBones()

virtual unsigned short Ogre::v1::Skeleton::getNumBones | ( | void |  | ) | const
| virtual

Returns the number of bones in this skeleton.

## ◆ getOrigin()

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const
| inlinevirtualinherited

Get the origin of this resource, e.g.

a script file name.

Remarks
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getRootBone()

virtual OldBone* Ogre::v1::Skeleton::getRootBone | ( | void |  | ) | const
| virtual

Gets the root bone of the skeleton: deprecated in favour of getRootBoneIterator.

Remarks
  The system derives the root bone the first time you ask for it. The root bone is the only bone in the skeleton which has no parent. The system locates it by taking the first bone in the list and going up the bone tree until there are no more parents, and saves this top bone as the root. If you are building the skeleton manually using createBone then you must ensure there is only one bone which is not a child of another bone, otherwise your skeleton will not work properly. If you use createBone only once, and then use OldBone::createChild from then on, then inherently the first bone you create will by default be the root.

## ◆ getRootBoneIterator()

virtual BoneIterator Ogre::v1::Skeleton::getRootBoneIterator | ( | void |  | ) |
| virtual

Get an iterator over the root bones in the skeleton, ie those with no parents.

## ◆ getSize()

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const
| inlinevirtualinherited

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getStateCount()

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const
| inlinevirtualinherited

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

## ◆ hasAnimation()

virtual bool Ogre::v1::Skeleton::hasAnimation | ( | const String & | name | ) | const
| virtual

Returns whether this skeleton contains the named animation.

Implements Ogre::v1::AnimationContainer.

## ◆ hasBone()

virtual bool Ogre::v1::Skeleton::hasBone | ( | const String & | name | ) | const
| virtual

Returns whether this skeleton contains the named bone.

## ◆ hasManualBones()

virtual bool Ogre::v1::Skeleton::hasManualBones | ( | void |  | ) | const
| inlinevirtual

Are there any manually controlled bones?

## ◆ isBackgroundLoaded()

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether this Resource has been earmarked for background loading.

Remarks
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isLoaded()

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isLoading()

virtual bool Ogre::Resource::isLoading | ( |  | ) | const
| inlinevirtualinherited

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isManuallyLoaded()

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Is this resource manually loaded?

## ◆ isPrepared()

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been prepared, false otherwise.

References Ogre::AtomicScalar< T >::get().

## ◆ isReloadable()

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ load()

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Loads the resource, if it is not already.

Remarks
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters

  backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ optimiseAllAnimations()

virtual void Ogre::v1::Skeleton::optimiseAllAnimations | ( | bool | preservingIdentityNodeTracks = `false` | ) |
| virtual

Optimise all of this skeleton's animations.

See also
  Animation::optimise

Parameters

  preservingIdentityNodeTracks | If true, don't destroy identity node tracks.

## ◆ prepare()

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters

  backgroundThread | Whether this is occurring in a background thread

## ◆ reload()

virtual void Ogre::Resource::reload | ( | LoadingFlags | flags = `LF_DEFAULT` | ) |
| virtualinherited

Reloads the resource, if it is already loaded.

Remarks
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram, and Ogre::v1::Mesh.

## ◆ removeAllLinkedSkeletonAnimationSources()

virtual void Ogre::v1::Skeleton::removeAllLinkedSkeletonAnimationSources | ( | void |  | ) |
| virtual

Remove all links to other skeletons for the purposes of sharing animation.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ removeAnimation()

virtual void Ogre::v1::Skeleton::removeAnimation | ( | const String & | name | ) |
| virtual

Removes an Animation from this skeleton.

Implements Ogre::v1::AnimationContainer.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ removeListener()

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) |
| virtualinherited

Remove a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ reset()

virtual void Ogre::v1::Skeleton::reset | ( | bool | resetManualBones = `false` | ) |
| virtual

Resets the position and orientation of all bones in this skeleton to their original binding position.

Remarks
  A skeleton is bound to a mesh in a binding pose. OldBone positions are then modified from this position during animation. This method returns all the bones to their original position and orientation.

Parameters

  resetManualBones | If set to true, causes the state of manual bones to be reset too, which is normally not done to allow the manual state to persist even when keyframe animation is applied.

## ◆ setAnimationState()

virtual void Ogre::v1::Skeleton::setAnimationState | ( | const AnimationStateSet & | animSet | ) |
| virtual

Changes the state of the skeleton to reflect the application of the passed in collection of animations.

Remarks
  Animating a skeleton involves both interpolating between keyframes of a specific animation, and blending between the animations themselves. Calling this method sets the state of the skeleton so that it reflects the combination of all the passed in animations, at the time index specified for each, using the weights specified. Note that the weights between animations do not have to sum to 1.0, because some animations may affect only subsets of the skeleton. If the weights exceed 1.0 for the same area of the skeleton, the movement will just be exaggerated.

## ◆ setBackgroundLoaded()

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) |
| inlinevirtualinherited

Tells the resource whether it is background loaded or not.

Remarks

See also
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setBindingPose()

virtual void Ogre::v1::Skeleton::setBindingPose | ( | void |  | ) |
| virtual

Sets the current position / orientation to be the 'binding pose' i.e.

the layout in which bones were originally bound to a mesh.

## ◆ setBlendMode()

virtual void Ogre::v1::Skeleton::setBlendMode | ( | SkeletonAnimationBlendMode | state | ) |
| virtual

Sets the animation blending mode this skeleton will use.

## ◆ setManuallyLoaded()

virtual void Ogre::Resource::setManuallyLoaded | ( | bool | isManual | ) |
| inlinevirtualinherited

Set "Is this resource manually loaded?".

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setToLoaded()

virtual void Ogre::Resource::setToLoaded | ( | void |  | ) |
| inlinevirtualinherited

Change the Resource loading state to loaded.

References Ogre::AtomicScalar< T >::set().

## ◆ touch()

virtual void Ogre::Resource::touch | ( | void |  | ) |
| virtualinherited

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram, and Ogre::Material.

Referenced by Ogre::Material::touch().

## ◆ unload()

virtual void Ogre::Resource::unload | ( | void |  | ) |
| virtualinherited

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## Friends And Related Function Documentation

## ◆ OldSkeletonInstance

friend class OldSkeletonInstance
| friend

## Member Data Documentation

## ◆ OGRE_AUTO_MUTEX

Ogre::Resource::OGRE_AUTO_MUTEX
| inherited

The documentation for this class was generated from the following file:

- OgreSkeleton.h